// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from robot_calibration_msgs:msg/Observation.idl
// generated code does not contain a copyright notice

#ifndef ROBOT_CALIBRATION_MSGS__MSG__DETAIL__OBSERVATION__BUILDER_HPP_
#define ROBOT_CALIBRATION_MSGS__MSG__DETAIL__OBSERVATION__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "robot_calibration_msgs/msg/detail/observation__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace robot_calibration_msgs
{

namespace msg
{

namespace builder
{

class Init_Observation_image
{
public:
  explicit Init_Observation_image(::robot_calibration_msgs::msg::Observation & msg)
  : msg_(msg)
  {}
  ::robot_calibration_msgs::msg::Observation image(::robot_calibration_msgs::msg::Observation::_image_type arg)
  {
    msg_.image = std::move(arg);
    return std::move(msg_);
  }

private:
  ::robot_calibration_msgs::msg::Observation msg_;
};

class Init_Observation_cloud
{
public:
  explicit Init_Observation_cloud(::robot_calibration_msgs::msg::Observation & msg)
  : msg_(msg)
  {}
  Init_Observation_image cloud(::robot_calibration_msgs::msg::Observation::_cloud_type arg)
  {
    msg_.cloud = std::move(arg);
    return Init_Observation_image(msg_);
  }

private:
  ::robot_calibration_msgs::msg::Observation msg_;
};

class Init_Observation_ext_camera_info
{
public:
  explicit Init_Observation_ext_camera_info(::robot_calibration_msgs::msg::Observation & msg)
  : msg_(msg)
  {}
  Init_Observation_cloud ext_camera_info(::robot_calibration_msgs::msg::Observation::_ext_camera_info_type arg)
  {
    msg_.ext_camera_info = std::move(arg);
    return Init_Observation_cloud(msg_);
  }

private:
  ::robot_calibration_msgs::msg::Observation msg_;
};

class Init_Observation_features
{
public:
  explicit Init_Observation_features(::robot_calibration_msgs::msg::Observation & msg)
  : msg_(msg)
  {}
  Init_Observation_ext_camera_info features(::robot_calibration_msgs::msg::Observation::_features_type arg)
  {
    msg_.features = std::move(arg);
    return Init_Observation_ext_camera_info(msg_);
  }

private:
  ::robot_calibration_msgs::msg::Observation msg_;
};

class Init_Observation_sensor_name
{
public:
  Init_Observation_sensor_name()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Observation_features sensor_name(::robot_calibration_msgs::msg::Observation::_sensor_name_type arg)
  {
    msg_.sensor_name = std::move(arg);
    return Init_Observation_features(msg_);
  }

private:
  ::robot_calibration_msgs::msg::Observation msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::robot_calibration_msgs::msg::Observation>()
{
  return robot_calibration_msgs::msg::builder::Init_Observation_sensor_name();
}

}  // namespace robot_calibration_msgs

#endif  // ROBOT_CALIBRATION_MSGS__MSG__DETAIL__OBSERVATION__BUILDER_HPP_
