// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from robot_calibration_msgs:msg/CalibrationData.idl
// generated code does not contain a copyright notice
#include "robot_calibration_msgs/msg/detail/calibration_data__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `joint_states`
#include "sensor_msgs/msg/detail/joint_state__functions.h"
// Member `observations`
#include "robot_calibration_msgs/msg/detail/observation__functions.h"

bool
robot_calibration_msgs__msg__CalibrationData__init(robot_calibration_msgs__msg__CalibrationData * msg)
{
  if (!msg) {
    return false;
  }
  // joint_states
  if (!sensor_msgs__msg__JointState__init(&msg->joint_states)) {
    robot_calibration_msgs__msg__CalibrationData__fini(msg);
    return false;
  }
  // observations
  if (!robot_calibration_msgs__msg__Observation__Sequence__init(&msg->observations, 0)) {
    robot_calibration_msgs__msg__CalibrationData__fini(msg);
    return false;
  }
  return true;
}

void
robot_calibration_msgs__msg__CalibrationData__fini(robot_calibration_msgs__msg__CalibrationData * msg)
{
  if (!msg) {
    return;
  }
  // joint_states
  sensor_msgs__msg__JointState__fini(&msg->joint_states);
  // observations
  robot_calibration_msgs__msg__Observation__Sequence__fini(&msg->observations);
}

bool
robot_calibration_msgs__msg__CalibrationData__are_equal(const robot_calibration_msgs__msg__CalibrationData * lhs, const robot_calibration_msgs__msg__CalibrationData * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // joint_states
  if (!sensor_msgs__msg__JointState__are_equal(
      &(lhs->joint_states), &(rhs->joint_states)))
  {
    return false;
  }
  // observations
  if (!robot_calibration_msgs__msg__Observation__Sequence__are_equal(
      &(lhs->observations), &(rhs->observations)))
  {
    return false;
  }
  return true;
}

bool
robot_calibration_msgs__msg__CalibrationData__copy(
  const robot_calibration_msgs__msg__CalibrationData * input,
  robot_calibration_msgs__msg__CalibrationData * output)
{
  if (!input || !output) {
    return false;
  }
  // joint_states
  if (!sensor_msgs__msg__JointState__copy(
      &(input->joint_states), &(output->joint_states)))
  {
    return false;
  }
  // observations
  if (!robot_calibration_msgs__msg__Observation__Sequence__copy(
      &(input->observations), &(output->observations)))
  {
    return false;
  }
  return true;
}

robot_calibration_msgs__msg__CalibrationData *
robot_calibration_msgs__msg__CalibrationData__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  robot_calibration_msgs__msg__CalibrationData * msg = (robot_calibration_msgs__msg__CalibrationData *)allocator.allocate(sizeof(robot_calibration_msgs__msg__CalibrationData), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(robot_calibration_msgs__msg__CalibrationData));
  bool success = robot_calibration_msgs__msg__CalibrationData__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
robot_calibration_msgs__msg__CalibrationData__destroy(robot_calibration_msgs__msg__CalibrationData * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    robot_calibration_msgs__msg__CalibrationData__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
robot_calibration_msgs__msg__CalibrationData__Sequence__init(robot_calibration_msgs__msg__CalibrationData__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  robot_calibration_msgs__msg__CalibrationData * data = NULL;

  if (size) {
    data = (robot_calibration_msgs__msg__CalibrationData *)allocator.zero_allocate(size, sizeof(robot_calibration_msgs__msg__CalibrationData), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = robot_calibration_msgs__msg__CalibrationData__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        robot_calibration_msgs__msg__CalibrationData__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
robot_calibration_msgs__msg__CalibrationData__Sequence__fini(robot_calibration_msgs__msg__CalibrationData__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      robot_calibration_msgs__msg__CalibrationData__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

robot_calibration_msgs__msg__CalibrationData__Sequence *
robot_calibration_msgs__msg__CalibrationData__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  robot_calibration_msgs__msg__CalibrationData__Sequence * array = (robot_calibration_msgs__msg__CalibrationData__Sequence *)allocator.allocate(sizeof(robot_calibration_msgs__msg__CalibrationData__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = robot_calibration_msgs__msg__CalibrationData__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
robot_calibration_msgs__msg__CalibrationData__Sequence__destroy(robot_calibration_msgs__msg__CalibrationData__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    robot_calibration_msgs__msg__CalibrationData__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
robot_calibration_msgs__msg__CalibrationData__Sequence__are_equal(const robot_calibration_msgs__msg__CalibrationData__Sequence * lhs, const robot_calibration_msgs__msg__CalibrationData__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!robot_calibration_msgs__msg__CalibrationData__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
robot_calibration_msgs__msg__CalibrationData__Sequence__copy(
  const robot_calibration_msgs__msg__CalibrationData__Sequence * input,
  robot_calibration_msgs__msg__CalibrationData__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(robot_calibration_msgs__msg__CalibrationData);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    robot_calibration_msgs__msg__CalibrationData * data =
      (robot_calibration_msgs__msg__CalibrationData *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!robot_calibration_msgs__msg__CalibrationData__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          robot_calibration_msgs__msg__CalibrationData__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!robot_calibration_msgs__msg__CalibrationData__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
